#ifndef BALL_H
#define BALL_H

#include "platform.h"
#include <QPainter>
#include <QTimer>
#include <qobjectdefs.h>

class Ball : public QTimer {
    Q_OBJECT

  public:
    Ball(QWidget* parent, std::shared_ptr<Platform> platform);

    void draw(QPainter& painter);

  signals:
    void fellThrough(Ball* ball);
    void caught(Ball* ball);

  protected:
    virtual void timerEvent(QTimerEvent*) override;

  private:
    QWidget* m_parent;
    std::shared_ptr<Platform> m_platform;
    double m_x;
    double m_y;
    double m_kx;
    double m_ky;
    bool m_isSpawning;
};

#endif // BALL_H
