#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "ball.h"
#include "platform.h"
#include <QKeyEvent>
#include <QMainWindow>
#include <QWidget>
#include <qevent.h>

QT_BEGIN_NAMESPACE
namespace Ui {
    class MainWindow;
}
QT_END_NAMESPACE

class MainWindow : public QMainWindow {
    Q_OBJECT

  public:
    MainWindow(QWidget* parent = nullptr);
    ~MainWindow();

    bool leftArrowPressed;
    bool rightArrowPressed;

  private slots:
    void ballFell(Ball* ball);
    void ballCaught(Ball* ball);
    void onBallSpawn();

  protected:
    virtual void paintEvent(QPaintEvent*) override;

    void deleteBall(Ball* ball);
    void spawnBall();

    void keyPressEvent(QKeyEvent* event) override;
    void keyReleaseEvent(QKeyEvent* event) override;

  private:
    float m_spawnInterval;
    QTimer m_spawnTimer;
    Ui::MainWindow* ui;
    QList<std::shared_ptr<Ball>> balls;
    std::shared_ptr<Platform> platform;
};
#endif // MAINWINDOW_H
